#ifndef UTILS__RUNWHEN__STUFF_H
#define UTILS__RUNWHEN__STUFF_H

#define FATAL PROG ": fatal: "
#define WARNING PROG ": warning: "

enum { null=0 };
#define null ((void*)null)

static char const err_malformed[]=" malformed";
static char const err_create[]=" unable to create ";
static char const err_close[]="unable to close ";
static char const err_exec[]="unable to execute ";
static char const err_stat[]="unable to stat ";
static char const err_sigempty[]="unable to empty signal set: ";
static char const err_sigfill[]="unable to fill signal set: ";
static char const err_sigadd[]="unable to add signal to set: ";
static char const err_sigdel[]="unable to remove signal from set: ";
static char const err_sigact[]="unable to set signal action: ";
static char const err[]=": ";

static char const* test_char_ptr;

#define die1(x_sys, status, x1) \
  ((void)(0!=0 && (test_char_ptr=(x1))), \
   strerr_die1##x_sys((status), (char*)(x1)))

#define die2(x_sys, status, x1, x2) \
  ((void)(0!=0 && (test_char_ptr=(x1))), \
   (void)(0!=0 && (test_char_ptr=(x2))), \
   strerr_die2##x_sys((status), (char*)(x1), (char*)(x2)))

#define die3(x_sys, status, x1, x2, x3) \
  ((void)(0!=0 && (test_char_ptr=(x1))), \
   (void)(0!=0 && (test_char_ptr=(x2))), \
   (void)(0!=0 && (test_char_ptr=(x3))), \
   strerr_die3##x_sys((status), (char*)(x1), (char*)(x2), (char*)(x3)))

#define die4(x_sys, status, x1, x2, x3, x4) \
  ((void)(0!=0 && (test_char_ptr=(x1))), \
   (void)(0!=0 && (test_char_ptr=(x2))), \
   (void)(0!=0 && (test_char_ptr=(x3))), \
   (void)(0!=0 && (test_char_ptr=(x4))), \
   strerr_die4##x_sys((status), (char*)(x1), (char*)(x2), (char*)(x3), \
                      (char*)(x4)))

#define die5(x_sys, status, x1, x2, x3, x4, x5) \
  ((void)(0!=0 && (test_char_ptr=(x1))), \
   (void)(0!=0 && (test_char_ptr=(x2))), \
   (void)(0!=0 && (test_char_ptr=(x3))), \
   (void)(0!=0 && (test_char_ptr=(x4))), \
   (void)(0!=0 && (test_char_ptr=(x5))), \
   strerr_die5##x_sys((status), (char*)(x1), (char*)(x2), (char*)(x3), \
                      (char*)(x4), (char*)(x5)))

#define die6(x_sys, status, x1, x2, x3, x4, x5, x6) \
  ((void)(0!=0 && (test_char_ptr=(x1))), \
   (void)(0!=0 && (test_char_ptr=(x2))), \
   (void)(0!=0 && (test_char_ptr=(x3))), \
   (void)(0!=0 && (test_char_ptr=(x4))), \
   (void)(0!=0 && (test_char_ptr=(x5))), \
   (void)(0!=0 && (test_char_ptr=(x6))), \
   strerr_die6##x_sys((status), (char*)(x1), (char*)(x2), (char*)(x3), \
                      (char*)(x4), (char*)(x5), (char*)(x6)))

#define envget(x) \
  ((void)(0!=0 && (test_char_ptr=x)), env_get((char*)x+1))

#define scan_ulong(x, var) \
  ((void)(0!=0 && (test_char_ptr=x)), scan_ulong((char*)x, var))

#endif
